% :-swi_module(user). 
:-swi_module(modSit, []).
/* * module * Agent Postures there and does nothing
% Agent will loose a bit of charge, but heal a bit of damage
% May 18, 1996
% John Eikenberry
% Douglas Miles 2014

*/
:- include(prologmud(mud_header)).

% :- register_module_type (mtCommand).



%=autodoc
%% ttValueType( ?ARG1) is semidet.
%
% Collection Type Value Type.
%
ttValueType(vtPosture).



%=autodoc
%% ==> ?IExplorer7 is semidet.
%
% ==>.
%
==>prologSingleValued(mudStance(tAgent,vtPosture),[prologHybrid,relationMostInstance(tAgent,vStand)]).



%=autodoc
%% prologHybrid( ?ARG1) is semidet.
%
% Prolog Hybrid.
%
prologHybrid(actSetsPosture(vtVerb,vtPosture)).



%=autodoc
%% vtPosture( ?ARG1) is semidet.
%
% Vt Posture.
%
vtPosture(vSit).
vtPosture(vStand).
vtPosture(vLay).
vtPosture(vSleep).
vtPosture(vKneel).

% converts vtPosture:"vSleep" to Action vtVerb:"actSleep"
vtPosture(PostureState)/i_name(act,PostureState,Action) ==>
   actSetsPosture(Action,PostureState).

%=autodoc
%%  ?Sub==> ?Super is semidet.
%
% ==>.
%


actSetsPosture(Action,PostureState) ==>
   {DO=..[Action,tFurniture]}, 
  action_info_prefered(DO,txtConcatFn(PostureState, " on ", tFurniture)).

actSetsPosture(Action,PostureState) ==> 
  action_info_prefered(Action,txtConcatFn("sets agent's stance to ",PostureState)).



%=autodoc
%% action_info( ?Say, ?Invokes) is semidet.
%
% Action Info.
%
baseKB:action_info(A,I):-action_info_prefered(A,I).

% Become PostureState on Something.
baseKB:agent_call_command(Agent,actOnto(Where,PostureState)):-
        fmt('agent ~w is now ~wing on ~w',[Agent,PostureState,Where]),
        padd(Agent,mudStance(PostureState)),
        padd(Agent,localityOfObject(Where)),
	call_update_charge(Agent,PostureState).

%=autodoc
%% agent_call_command( ?Agent, ?ACT) is semidet.
%
% Agent Call Command.
%


% PostureState Action Direct
baseKB:agent_call_command(Agent,Action):- callable(Action),
     functor(Action,Act,_),
     actSetsPosture(Act,PostureState),
     (compound(Action)->arg(1,Action,Where);Where=vHere),
     baseKB:agent_call_command(Agent,actOnto(Where,PostureState)).




%=autodoc
%% update_charge( ?A, ?B) is semidet.
%
% Update Charge.
%
update_charge(Agent,PostureState) :- vtPosture(PostureState), padd(Agent,mudEnergy(+ -1)).

:- include(prologmud(mud_footer)).
